plugins.Mixer = {
  version: "1.0.0.1",
  lastChange: "Nov 25th, 2008",
  displayName: "Mixer",
  aliasstr: "mixer",
  directory: currentDirectory,
  icon: currentDirectory + "\\Mixer.ico",
  scorestr: "300"
};
// XXX: doing things this way to protect from namespace pollution
(function () {
  var m = plugins.Mixer;
  var _urlregexstr = "([^ ]+)";
  // XXX: doesn't support regular expressions containing double quotes
  var _grabregexstr = "\"([^\"]+)\"";
  // XXX: doesn't support templates containing double quotes
  var _templateregexstr = "\"([^\"]+)\"";
  m.regexstr = 
    // see _helpmsg variable below for example
    // XXX: could try to handle varying whitespace between arguments...
    "^" + m.aliasstr + " ?" + _urlregexstr + " ?" + 
    _grabregexstr + " ?" + _templateregexstr;
  var _displayStatus = function (message) {
    setStatusBar("Webgrab - " + message);
  }
  var _reportError = function (message) {
    // XXX: hack to retrieve name of calling function...
    var fnasstr = arguments.callee.caller.toString();
    var res = /^function ([^\(]+)\(/.exec(fnasstr);
    var fnname = "anonymous";
    if (res !== null) {
      fnname = res[1];
    } else {
      res = /@fn: ([^ ]+) /.exec(fnasstr); // for anonymous functions
      if (res !== null) {
	fnname = res[1];
      }
    }
    reportError(fnname + ": " + message);
  }
  var _loadFile = function (file, string) {
    if (string === undefined) {
      string = false;
    }
    var text;
    if (fso.FileExists(file)) {
      text = getTextFile(file);
    } else {
      throw "file does not exist: " + file;
    }
    var r_string;
    if (string === false) {
      r_string = eval(text);
    } else {
      r_string = text;
    }
    return r_string;
  }
  var _dbgout = function (message) {
    //FARR.debug(message);
  }
  var _displayResults = function (message, mode) {
    function stringHasHtml(message) {
      // XXX: cheap hack
      var htmlre = /<([a-z]+ ?)/i;
      if (htmlre.test(message)) { return true; } 
      else { return false; }
    }
    if ((!mode) || (mode == "auto")) {
      if (stringHasHtml(message)) { 
	showHTML(message); 
      } else { 
	setRichEditMode(message); 
      }
    } else if (mode == "richedit") { 
      setRichEditMode(message); 
    } else if (mode == "html") { 
      showHTML(message); 
    } else { 
      _reportError("Error: unexpected mode value: " + mode); 
    }
  }
  try {
    m._helpmsg = _loadFile(m.directory + "\\usage.txt", true);
    m._Webgrab = _loadFile(m.directory + "\\lib\\webgrab.js", false);
  } catch (err) {
    _reportError("Error: " + (err.number & 0xFFFF) + ": " + err.description);
  }
  m.search = function (querykey, explicit, queryraw, querynokeyword, 
                       modifier, triggermethod) {
    // @fn: Plugins.Mixer.search
    if (!explicit) { return; }
    var message = 
      this._helpmsg + 
      "\n" + 
      "\n" +
      "So far:\n" +
      "\n" +
      "  " + queryraw +
      ""; 
    _displayStatus("Help Message");
    _displayResults(message, "richedit");
    var marray = queryraw.match(this.regexstr);
    if (marray === null) { return; }
    var url = marray[1];
    var regexpstr = marray[2];
    var template = marray[3];
    function callback (message) {
      // @fn: callback
      _displayStatus(url);
      _displayResults(message);
    }
    function errback (message) {
      // @fn: errback
      _displayStatus("failed");
      message =
        "Failed to complete processing for: \n" + 
        "url: " + url + "\n" + 
        "regular expression: " + regexpstr + "\n" +
        "template: " + template + "\n" +          
        "error: " + message + "\n";
      _displayResults(message, "richedit");
      _reportError(message);
    }
    function updatefn (message) {
      // @fn: updatefn
      _displayStatus(message);
    }
    if (!this._Webgrab.doGrabRep(querykey, url, regexpstr, template, true,
                                 callback, errback, updatefn)) {
      // XXX
    }
  };
}());

// Local Variables:
// c-basic-offset: 2
// End: