//
Webgrab = {
  //
  fillTemplate: function (marray, template) {
    // @fn: Webgrab.fillTemplate
    var nmatches = marray.length - 1;
    var matchnum = null;
    var message = "no message";
    // XXX: if the following pattern changes, make sure to examine and 
    //      possibly update replacerFn       
    var regexp = /([^%]*)(%(\d+))/g;
    var resultstr = null;
    // note: p1, p2, and p3 refer to the 3 strings matched by the 
    // 3 parenthesized subpatterns within regexp
    function replacerFn(str, p1, p2, p3, offset, s) {
      matchnum = parseInt(p3);
      // checking whether index is in range
      // XXX: may be just skip the matched %-number and leave it untouched?
      if (matchnum > nmatches) {
        message = "Error: template specifies %" + p3 + 
                  ", but regexp only matches " + nmatches + "patterns"; 
        throw new Error(message);
      }
      return p1 + marray[matchnum];
    }
    try {        
      resultstr = template.replace(regexp, replacerFn);
    } catch (err) {
      return null;
    }
    return resultstr;
  },
  //
  doGrabRep: function (querykey, url, regexpstr, template, async,
                       callback, errback, updatefn) {
    // @fn: Webgrab.doGrabRep
    var self = this;
    if ((async === null) || (async === undefined)) { async = true ;}
    if (typeof(callback) !== "function") { 
      callback = function (message) {
        return message;
      }; 
    }
    // XXX: is this appropriate?
    if (typeof(errback) !== "function") { 
      errback = function (message) {
        return false;
      }; 
    }
    if (typeof(updatefn) !== "function") { updatefn = function (message) {}; }
    var xhr = null;
    try {
      xhr = new ActiveXObject("MSXML2.XMLHTTP");
    } catch (err) { // XXX: how can we test this case?
      message = "Error: construction of ActiveXObject failed to create xhr";
      errback(message);
      return false;
    }
    var regexp = new RegExp(regexpstr);  
    updatefn("Creating request to send to server");
    //
    function handleLoaded () {
      if (xhr.status != 200) {
        message = 
          "Error: server returned non-200 response code: " + 
          "status: " + xhr.status + " " +
          "statusText: " + xhr.statusText;
        return errback(message);
      }
      if (xhr.responseText == "") {
        message = "Error: server gave an empty response";
        return errback(message);
      }      
      var marray = regexp.exec(xhr.responseText);
      if (marray == null) {
        message = "Error: regular expression didn't match anything in " + 
                  "server response";
        return errback(message);
      }
      try {
        message = self.fillTemplate(marray, template);
      } catch (err) {
        // 
        return errback(err.message);
      }
      if (message != null) {
        return callback(message);
      } else {
        return errback(message);
      }
    }
    //
    xhr.onreadystatechange = function onreadystatechange() {
      // @fn: onreadystatechange
      var message = "no message";
      // XXX: cases 0, 1, 2, and 3 we are not interested in unless
      //      we want to debug, perhaps
      if (xhr.readyState == 0) {
      } else if (xhr.readyState == 1) {
      } else if (xhr.readyState == 2) {
        updatefn("Sending request to server");
      } else if (xhr.readyState == 3) {
        updatefn("Receiving data from server");
      } else if (xhr.readyState == 4) { // 4 means ready with response
        if (async === true) {
          handleLoaded();
        }
      } else {
        message = "Error: unknown readyState: " + xhr.readyState;
        return errback(message);     
      }
    }
    // XXX: consider supporting POST at some point - defaulting here to GET
    //      seems to make sense
    try {
      xhr.open("GET", url, async);
    } catch (err) {
      message = "Error: open() exception: " + err.name + " " + err.message;
      errback(message);
      return false;
    }
    try {
      xhr.send();
    } catch (err) {
      // XXX: improve handling here? -- DOMException, INVALID_STATE_ERR
      message = "Error: send() exception: " + err.name + " " + err.message;
      errback(message);
      return false;
    }
    // XXX: what about request timeout?
    if (async === true) {
      return true;
    }
    else { // should be: xhr.readystate: 4, XXX: other conditions?
      message = handleLoaded();
      /*
      // XXX: blech...filtering on string content
      var marray = /^Error: /.exec(message);
      if (marray != null) {
        return false;
      }
      */
      return message;
    }
  },
  // XXX: what about querykey...?
  doGrabRepSync: function (url, regexpstr, template) {
    // @fn: Webgrab.doGrabRepSync
    return this.doGrabRep(null, url, regexpstr, template, false)
  }
};
